<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>MultiResponse.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">MultiResponse.java</span></div><h1>MultiResponse.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the &quot;License&quot;); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.proto.CreateResponse;
import org.apache.zookeeper.proto.MultiHeader;
import org.apache.zookeeper.proto.SetDataResponse;
import org.apache.zookeeper.proto.ErrorResponse;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Handles the response from a multi request.  Such a response consists of
 * a sequence of responses each prefixed by a MultiResponse that indicates
 * the type of the response.  The end of the list is indicated by a MultiHeader
 * with a negative type.  Each individual response is in the same format as
 * with the corresponding operation in the original request list.
 */
<span class="fc" id="L40">public class MultiResponse implements Record, Iterable&lt;OpResult&gt; {</span>
<span class="fc" id="L41">    private List&lt;OpResult&gt; results = new ArrayList&lt;OpResult&gt;();</span>

    public void add(OpResult x) {
<span class="fc" id="L44">        results.add(x);</span>
<span class="fc" id="L45">    }</span>

    @Override
    public Iterator&lt;OpResult&gt; iterator() {
<span class="nc" id="L49">        return results.iterator();</span>
    }

    public int size() {
<span class="nc" id="L53">        return results.size();</span>
    }

    @Override
    public void serialize(OutputArchive archive, String tag) throws IOException {
<span class="fc" id="L58">        archive.startRecord(this, tag);</span>

<span class="fc" id="L60">        int index = 0;</span>
<span class="fc bfc" id="L61" title="All 2 branches covered.">        for (OpResult result : results) {</span>
<span class="fc bfc" id="L62" title="All 2 branches covered.">            int err = result.getType() == ZooDefs.OpCode.error ? ((OpResult.ErrorResult)result).getErr() : 0;</span>

<span class="fc" id="L64">            new MultiHeader(result.getType(), false, err).serialize(archive, tag);</span>

<span class="pc bpc" id="L66" title="1 of 5 branches missed.">            switch (result.getType()) {</span>
                case ZooDefs.OpCode.create:
<span class="fc" id="L68">                    new CreateResponse(((OpResult.CreateResult) result).getPath()).serialize(archive, tag);</span>
<span class="fc" id="L69">                    break;</span>
                case ZooDefs.OpCode.delete:
                case ZooDefs.OpCode.check:
<span class="fc" id="L72">                    break;</span>
                case ZooDefs.OpCode.setData:
<span class="fc" id="L74">                    new SetDataResponse(((OpResult.SetDataResult) result).getStat()).serialize(archive, tag);</span>
<span class="fc" id="L75">                    break;</span>
                case ZooDefs.OpCode.error:
<span class="fc" id="L77">                    new ErrorResponse(((OpResult.ErrorResult) result).getErr()).serialize(archive, tag);</span>
<span class="fc" id="L78">                    break;</span>
                default:
<span class="nc" id="L80">                    throw new IOException(&quot;Invalid type &quot; + result.getType() + &quot; in MultiResponse&quot;);</span>
            }
<span class="fc" id="L82">        }</span>
<span class="fc" id="L83">        new MultiHeader(-1, true, -1).serialize(archive, tag);</span>
<span class="fc" id="L84">        archive.endRecord(this, tag);</span>
<span class="fc" id="L85">    }</span>

    @Override
    public void deserialize(InputArchive archive, String tag) throws IOException {
<span class="fc" id="L89">        results = new ArrayList&lt;OpResult&gt;();</span>

<span class="fc" id="L91">        archive.startRecord(tag);</span>
<span class="fc" id="L92">        MultiHeader h = new MultiHeader();</span>
<span class="fc" id="L93">        h.deserialize(archive, tag);</span>
<span class="fc bfc" id="L94" title="All 2 branches covered.">        while (!h.getDone()) {</span>
<span class="pc bpc" id="L95" title="1 of 6 branches missed.">            switch (h.getType()) {</span>
                case ZooDefs.OpCode.create:
<span class="fc" id="L97">                    CreateResponse cr = new CreateResponse();</span>
<span class="fc" id="L98">                    cr.deserialize(archive, tag);</span>
<span class="fc" id="L99">                    results.add(new OpResult.CreateResult(cr.getPath()));</span>
<span class="fc" id="L100">                    break;</span>

                case ZooDefs.OpCode.delete:
<span class="fc" id="L103">                    results.add(new OpResult.DeleteResult());</span>
<span class="fc" id="L104">                    break;</span>

                case ZooDefs.OpCode.setData:
<span class="fc" id="L107">                    SetDataResponse sdr = new SetDataResponse();</span>
<span class="fc" id="L108">                    sdr.deserialize(archive, tag);</span>
<span class="fc" id="L109">                    results.add(new OpResult.SetDataResult(sdr.getStat()));</span>
<span class="fc" id="L110">                    break;</span>

                case ZooDefs.OpCode.check:
<span class="fc" id="L113">                    results.add(new OpResult.CheckResult());</span>
<span class="fc" id="L114">                    break;</span>

                case ZooDefs.OpCode.error:
                    //FIXME: need way to more cleanly serialize/deserialize exceptions
<span class="fc" id="L118">                    ErrorResponse er = new ErrorResponse();</span>
<span class="fc" id="L119">                    er.deserialize(archive, tag);</span>
<span class="fc" id="L120">                    results.add(new OpResult.ErrorResult(er.getErr()));</span>
<span class="fc" id="L121">                    break;</span>

                default:
<span class="nc" id="L124">                    throw new IOException(&quot;Invalid type &quot; + h.getType() + &quot; in MultiResponse&quot;);</span>
            }
<span class="fc" id="L126">            h.deserialize(archive, tag);</span>
        }
<span class="fc" id="L128">        archive.endRecord(tag);</span>
<span class="fc" id="L129">    }</span>

    public List&lt;OpResult&gt; getResultList() {
<span class="fc" id="L132">        return results;</span>
    }

    @Override
    public boolean equals(Object o) {
<span class="pc bpc" id="L137" title="1 of 2 branches missed.">        if (this == o) return true;</span>
<span class="pc bpc" id="L138" title="1 of 2 branches missed.">        if (!(o instanceof MultiResponse)) return false;</span>

<span class="fc" id="L140">        MultiResponse other = (MultiResponse) o;</span>

<span class="pc bpc" id="L142" title="1 of 2 branches missed.">        if (results != null) {</span>
<span class="fc" id="L143">            Iterator&lt;OpResult&gt; i = other.results.iterator();</span>
<span class="fc bfc" id="L144" title="All 2 branches covered.">            for (OpResult result : results) {</span>
<span class="pc bpc" id="L145" title="1 of 2 branches missed.">                if (i.hasNext()) {</span>
<span class="pc bpc" id="L146" title="1 of 2 branches missed.">                    if (!result.equals(i.next())) {</span>
<span class="nc" id="L147">                        return false;</span>
                    }
                } else {
<span class="nc" id="L150">                    return false;</span>
                }
<span class="fc" id="L152">            }</span>
<span class="pc bpc" id="L153" title="1 of 2 branches missed.">            return !i.hasNext();</span>
        }
<span class="nc bnc" id="L155" title="All 2 branches missed.">        else return other.results == null;</span>
    }

    @Override
    public int hashCode() {
<span class="fc" id="L160">        int hash = results.size();</span>
<span class="fc bfc" id="L161" title="All 2 branches covered.">        for (OpResult result : results) {</span>
<span class="fc" id="L162">            hash = (hash * 35) + result.hashCode();</span>
<span class="fc" id="L163">        }</span>
<span class="fc" id="L164">        return hash;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>